01 <?php
02 namespace Example\Aspect;
03 
04 use PDO;
05 use Go\Aop\Aspect;
06 use Go\Aop\Intercept\MethodInvocation;
07 use Go\Lang\Annotation\Around;
08 
09 class TransactionAspect implements Aspect
10 {
11   protected $connection;
12   static protected $count = 0;
13 
14   /**
15    * @Around("@annotation(Example\Aspect\Annotation\Transactional)")
16    */
17   public function around(MethodInvocation $invocation)
18   {
19     $obj = $invocation->getThis();
20     echo 'Transactional : ' . get_class($obj) . PHP_EOL;
21 
22     ++self::$count;
23     try {
24       if (self::$count === 1) {
25         $this->connection->beginTransaction();
26       }
27       $result = $invocation->proceed();
28       if (self::$count === 1) {
29         $this->connection->commit();
30       }
31       --self::$count;
32     } catch (\Exception $exception) {
33       if (self::$count === 1) {
34         $this->connection->rollback();
35       }
36       --self::$count;
37       throw $exception;
38     }
39 
40     return $result;
41   }
42 
43   public function setConnection($connection)
44   {
45     $this->connection = $connection;
46   }
47 }
